started = false;
show_images = [];
bubbles = [];
current_image = 0;

one   = [{x:250, y:250, r:230}];
two   = [{x:177, y:221, r:320}, {x:380, y:600, r:218}]
three = [{x:112, y:80,  r:230}, {x:190, y:593, r:248}, {x:390, y:338, r:180}]
four  = [{x:137, y:104, r:173}, {x:289, y:427, r:280}, {x:403, y:124, r:135},
         {x:397, y:689, r:103}]

paths = [one, two, three, four];


function calc_image(img)
{
    var w = img.width;
    var h = img.height;

    h = h * (500 / w);
    w = 500;

    if(h < 500)
    {
        w = w * (500 / h);
        h = 500;
    }

    img.w = w;
    img.h = h;

    img.l = Math.floor((500 - w) / 2);
    img.t = Math.floor((500 - h) / 2);
}


function insert_css(code)
{
    var style  = document.createElement("style");
    style.type = "text/css";
    style.innerHTML = code;
    document.head.appendChild(style);
}


function make_all_path_css()
{
    for(var i=0; i<paths.length; i++)
    {
        var objs = paths[i];

        for(var k=0; k<objs.length; k++)
        {
            one = objs[k];

            make_path_css(-500, -500, one.x, one.y, one.r);
            make_path_css(1000, -500, one.x, one.y, one.r);
            make_path_css(-500, 1350, one.x, one.y, one.r);
            make_path_css(1000, 1350, one.x, one.y, one.r);            
        }
    }
}


function rand(min, max)
{
    return Math.floor(Math.random() * (max - min));
}

function rand_list()
{
    var nums = ['0', '0.1', '0.2', '0.3', '0.4'];

    for(var i=0; i<5; i++)
    {
        var i0 = rand(0, 5);
        var i1 = rand(0, 5);

        var tmp = nums[i0];
        nums[i0] = nums[i1];
        nums[i1] = tmp;
    }

    return nums;
}


function make_path_css(sx, sy, dx, dy, r)
{
    var name = "ani_" + sx + "_" + sy + "_" + dx + "_" + dy + "_" + r;
    name = name.replace(/\-/g, "n");

    sx += 1000;
    sy += 1000;
    dx += 1000;
    dy += 1000;

    var mx = dx + 40;
    var my = dy + 40;
    var mx2 = dx - 40;
    var my2 = dy - 40;

    if(dx < sx)
    {
        mx = dx - 40;
        mx2 = dx + 40;
    }

    if(dy < sy)
    {
        my = dy - 40;
        my2 = dy + 40;
    }
    
    var dx2, dy2;

    if(sx - 1000< 0)
    {
        dx2 = 1000 + 1000;
    }
    else
    {
        dx2 = -500 + 1000;
    }

    if(sy - 1000< 0)
    {
        dy2 = 1350 + 1000;
    }
    else
    {
        dy2 = -500 + 1000;
    }

    var css = "";
    

    css += "@-webkit-keyframes " + name + "{\n";
    css += "0%{-webkit-transform: translate(" + (sx-r)  + "px, " + (sy-r) + "px) rotate(0deg)}\n";
    css += "24%{-webkit-transform: translate(" + (mx-r) + "px, " + (my-r) + "px) rotate(360deg)}\n";
    css += "29%{-webkit-transform: translate(" + (dx-r) + "px, " + (dy-r) + "px) rotate(360deg)}\n";
    css += "73%{-webkit-transform: translate(" + (dx-r) + "px, " + (dy-r) + "px) rotate(360deg)}\n";
    css += "78%{-webkit-transform: translate(" + (mx2-r) + "px, " + (my2-r) + "px) rotate(360deg)}\n";
    css += "100%{-webkit-transform: translate(" + (dx2-r) + "px, " + (dy2-r) + "px) rotate(720deg)}\n";
    css += "}\n";

    insert_css(css);
    console.log(css);
}


function crate_bubbles()
{
    for(var i=0; i<5; i++)
    {
        var one = document.createElement('div');
        bubbles.push(one);
        
        one.style.position = 'absolute';
        one.style.borderRadius = '99em';
        one.style.opacity = 0.98;

        one.style.left = '-1000px';
        one.style.top  = '-1000px';
        one.style.width = '100px';
        one.style.height = '100px';
        one.style.visibility = 'visible';
        one.style.backgroundColor = 'white';

        var circle = new Image();
        
        one.appendChild(circle);
        
        var src_rand=rand(0,1)
        if(src_rand==0)
            circle.src = "img/klove/13.png";
        else
            circle.src = "img/klove/12.png";
        circle.width = "100";
        circle.height = "100";
        circle.style.visibility = 'visible';
        
        //document.body.appendChild(circle);

        one.circle = circle;

        id('content').appendChild(one);
    }
}


function get_ok_image()
{
    for(var i=0; i<show_images.length; i++)
    {
        var sel = (current_image + i) % show_images.length;

        if(show_images[sel].ok)
        {
            current_image = (sel + 1) % show_images.length;
            return show_images[sel];
        }
    }

    return false;
}


function apply_image(bubble, w, h)
{
    var img = get_ok_image();
    var iw  = img.width;
    var ih  = img.height;

    ih = ih * w / iw;
    iw = w;

    if(ih < h)
    {
        iw = iw * h / ih;
        ih = h;
    }

    iw = Math.floor(iw);
    ih = Math.floor(ih);

    var x = Math.floor((w - iw) / 2);
    var y = Math.floor((h - ih) / 2);

    bubble.style.backgroundImage = "url(" + img.src + ")";
    bubble.style.backgroundSize  = iw + "px " + ih + "px";
    bubble.style.backgroundPosition = x + "px " + y + "px";
}

var style_1=0; 

function begin_show()
{
    var i = rand(0, paths.length);
    var objs = paths[i];

    var m = rand(0, 4);
    var nums = rand_list();

    for(var k=0; k<objs.length; k++)
    {
        // if(objs.length==1)
            // alert();

        o = objs[k];
        b = bubbles[k];

        b.style.width  = o.r * 2 + "px";
        b.style.height = o.r * 2 + "px";

        apply_image(b, o.r*2, o.r*2);

        b.circle.width = o.r * 2;
        b.circle.height = o.r * 2;
        b.circle.style.position = "absolute";
        b.circle.style.left = "0px";
        b.circle.style.top  = "0px";

        var sx, sy;

        if(m == 0)
        {
            sx = -500;
            sy = -500;
        }
        else if(m == 1)
        {
            sx = 1000;
            sy = -500;
        }
        else if(m == 2)
        {
            sx = -500;
            sy = 1350;
        }
        else if(m == 3)
        {
            sx = 1000;
            sy = 1350;
        }

        var name = "ani_" + sx + "_" + sy + "_" + o.x + "_" + o.y + "_" + o.r;
        name = name.replace(/\-/g, "n");

        console.log("ani select " + name);

        //var wt = nums[k];
        wt = 0.7 * k;

        if(objs.length==1)
        {
            // b.style.webkitAnimation='center_ani 3.5s ease-in-out both';
            if(style_1==0)
            {
                b.style.webkitAnimation='center_ani 3.5s ease-in-out both';
                style_1=1;
            }   
            else
            {
                b.style.webkitAnimation='roll_ani 3.5s ease-in-out both';
                style_1=0;
            } 

        }
        else
            b.style.webkitAnimation = name + " 3.5s ease-in-out " + wt + "s both";

    }
    var ts = (objs.length -1) * 700 + 4000;
    setTimeout("clean_ani()", ts);
}


function clean_ani()
{
    for(var i=0; i<bubbles.length; i++)
    {
        bu = bubbles[i];
        bu.style.webkitAnimation = "";
    }

    setTimeout("begin_show()", 10);
}


function on_image_load(event)
{
    var img = event.target;
    img.ok = true;
    calc_image(img);

    if(!started && show_images[0].ok &&show_images[1].ok &&show_images[2].ok &&show_images[3].ok)
    {
        started = true;
        begin_show();
    }
}


function set_background()
{
    // document.body.style.backgroundImage = "url(http://7xjeju.com2.z0.glb.qiniucdn.com/pic/love/lovebg.jpg)";
    document.body.style.backgroundSize = "500px " + document.body.scrollHeight + "px";
}

function id(name)
{
    return document.getElementById(name)
}
function scene_init()
{
    eyeOpen();
    set_background();
    crate_bubbles();
    make_all_path_css();

    var urls = [];
    for(var i in slider_images_url)
    {
        urls[i] = slider_images_url[i];
    }

    if(urls.length == 1)
    {
        urls[1] = urls[0];
    }

    if(urls.length == 2)
    {
        urls[2] = urls[0];
    }

    if(urls.length == 3)
    {
        urls[3] = urls[0];
    }

    for(var i=0; i<urls.length; i++)
    {
        var img = new Image();
        show_images.push(img);
        img.i = i;
        img.ok = false;
        img.onload = on_image_load;
        img.src = urls[i];
    }
}

function eyeOpen()
        {
            var p = setInterval(function()
            {
                id('eye_2').style.display = 'none';
                id('eye_1').style.display = 'block';
                id('eye_4').style.display = 'none';
                id('eye_3').style.display = 'block';
            setTimeout(function()
            {
                id('eye_1').style.display = 'none';
                id('eye_2').style.display = 'block';
                id('eye_3').style.display = 'none';
                id('eye_4').style.display = 'block';
            },3000);
            },5000);
            
        }

call_me(scene_init);