curr_index  = 0;
show_images = [];
started = false;
next_show_timer = 0;
animation_timer = 0;
scroll_a_i = 0;

function reset_scene()
{
	clearTimeout(animation_timer);
	clearTimeout(next_show_timer);

	curr_index = 0;
	show_images = [];
	animation_timer = 0;
	next_show_timer = 0;
	started = false;

	band.style.webkitAnimation = '';

	load_images();
	begin_show();
}

function rand(min, max)
{
	return min + Math.floor(Math.random()*(max-min+1));
}

function calc_image(event)
{
	var img = event.target;
	img.ok = true;
	var w = img.width;
	var h = img.height;

	h = h * (502 / w);
	w = 502;

	if(h < 502)
	{
		w = w * (502 / h);
		h = 502;
	}

	img.w = w;
	img.h = h;

	img.si = w + 'px, ' + h + 'px';
	img.pos = Math.floor((500 - w)/2) + 'px, ' + Math.floor((500 - h)/2) + 'px';

	begin_show();
}

function set_bkimg(coverid, img)
{
	var cover = document.getElementById(coverid);
	cover.style.backgroundImage = 'url(' + img.src + ')';
	cover.style.backgroundPosition = img.pos;
	console.log(img.pos);
	cover.style.backgroundSize = img.si;
	cover.style.backgroundRepeat = 'no-repeat';
}

function clean_animation()
{
	next_show_timer = setTimeout('next_show()', 500);
}

function next_show()
{
	var img1 = curr_index;
	var img2 = (curr_index + 1) % show_images.length;
	var img3 = (curr_index + 2) % show_images.length;

	curr_index = (curr_index + 1) % show_images.length;

	var ani = rand(0, 1);

	if(ani == 0)
	{
		set_bkimg('cover1', show_images[img1]);
		set_bkimg('cover2', show_images[img2]);
		set_bkimg('cover3', show_images[img3]);

		var ani = 'scroll_a_' + scroll_a_i;
		scroll_a_i = (scroll_a_i + 1) % 2;

		band.style.webkitAnimation = ani + ' 0.9s ease-in-out both';
		animation_timer = setTimeout('next_show()', 2200);
	}
	else
	{
		set_bkimg('cover1', show_images[img1]);
		set_bkimg('cover2', show_images[img3]);
		set_bkimg('cover3', show_images[img2]);
		set_bkimg('cover4', show_images[img3]);

		var ani = 'scroll_b_' + scroll_a_i;
		scroll_a_i = (scroll_a_i + 1) % 2;

		band.style.webkitAnimation = ani + ' 1.6s ease-in-out both';
		animation_timer = setTimeout('next_show()', 4200);
	}
}

function begin_show()
{
	if(!started && show_images[0].ok == true && show_images[1].ok == true && show_images[2].ok == true)
	{
		started = true;
		next_show();
	}
}

function load_images()
{
	var urls = [];
    for(var i in slider_images_url)
    {
        urls[i] = slider_images_url[i];
    }
    if(urls.length == 1)
    {
        urls[1] = urls[0];
    }

    if(urls.length == 2)
    {
        urls[2] = urls[0];
    }

	for(var i=0; i<urls.length; i++)
	{
		var one = new Image();
		one.index = i;
		one.ok = false;
		one.onload = calc_image;
		show_images.push(one);
		one.src = urls[i];
		console.log(one.src);
	}
}

function roll_init()
{
	load_images();
}

call_me(roll_init);